#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/types.h>
#include <dirent.h>
#include <assert.h>
#include <unistd.h>
#include <string.h>

#define NBMAXDOCS 20
#define MAXDIRNAME 80

int nbDocIndexes = 0;
int nbThreads = 0;
char docname[MAXDIRNAME];
char dirname[MAXDIRNAME];

void *indexer_document(void *arg)
{
  char *docname = (char *)arg;
  printf("Debut indexer document =%s\n", docname);

  sleep(3);

  printf("Fin indexer document =%s\n", docname);
  nbDocIndexes ++;
  pthread_exit(NULL);
}


void indexer_repertoire(DIR *dir)
{

  struct dirent *entry;

  pthread_t thread;
  int rc, i = 0;

  do {
    entry = readdir(dir);
    if (entry == NULL)
      break;

    strcpy(docname, entry->d_name); 

    
    nbThreads ++;
    rc = pthread_create(&thread, NULL, indexer_document, docname); 

    if (rc)
      {
	perror("pthread_create");
	exit(EXIT_FAILURE);
      }
    i++;
    
  } while (i < NBMAXDOCS); 

  if (i == NBMAXDOCS) 
    {
      fprintf(stderr, "Indexation incomplete: le nombre de documents est superieur a NBMAXDOCS (%d)\n", NBMAXDOCS);
    }
}


int main(int argc, char **argv)
{
  DIR *directory;
  int i;
  
  if (argc < 2)
    {
      fprintf(stderr, "Usage: %s listeRepertoires\n", argv[0]);
      exit(EXIT_FAILURE);
    }


  for (i = 1; i < argc; i++)
    {

      assert(strlen(argv[i]) < MAXDIRNAME);
      strcpy(dirname, argv[i]);

      directory = opendir(dirname);
      if (directory == NULL)
	{
	    perror("opendir");
	    exit(EXIT_FAILURE);
	  }

      indexer_repertoire(directory);
      closedir(directory);  

    } 

  printf("Le nombre de threads crees est = %d\n", nbThreads);

  printf("Le nombre de documents indexes est = %d\n", nbDocIndexes);

  exit(EXIT_SUCCESS);
}

